A - Tickets HDU - 1260(动态规划)

Jesus, what a great movie! Thousands of people are rushing to the cinema. However, this is really a tuff time for Joe who sells the film tickets. He is wandering when could he go back home as early as possible.
A good approach, reducing the total time of tickets selling, is let adjacent people buy tickets together. As the restriction of the Ticket Seller Machine, Joe can sell a single ticket or two adjacent tickets at a time.
Since you are the great JESUS, you know exactly how much time needed for every person to buy a single ticket or two tickets for him/her. Could you so kind to tell poor Joe at what time could he go back home as early as possible? If so, I guess Joe would full of appreciation for your help.
Input
There are N(1<=N<=10) different scenarios, each scenario consists of 3 lines:

  1. An integer K(1<=K<=2000) representing the total number of people;
  2. K integer numbers(0s<=Si<=25s) representing the time consumed to buy a ticket for each person;
  3. (K-1) integer numbers(0s<=Di<=50s) representing the time needed for two adjacent people to buy two tickets together.
    Output
    For every scenario, please tell Joe at what time could he go back home as early as possible. Every day Joe started his work at 08:00:00 am. The format of time is HH:MM:SS am|pm.
    Sample Input
    2
    2
    20 25
    40
    1
    8
    Sample Output
    08:00:40 am
    08:00:08 am
    每一次买都有两种选择,自己买还有和前一个人一起买。所以每次选择的时候都要在这两种选择中找出一个最小值。dp[0][i]和dp[1][i]分别代表两种情况。
    代码如下:
#include<iostream>
#include<cstdio>
#include<cmath>
#include<cstring>
using namespace std;

const int maxx=2e3+1;

int dp[2][maxx];
int a[2001];
int b[2001];

int main()
{
    int n,k;
    scanf("%d",&n);
    while(n--)
    {
        scanf("%d",&k);
        for(int i=1;i<=k;i++)
            cin>>a[i];
        for(int i=2;i<=k;i++)
            cin>>b[i];
        dp[0][1]=a[1];
        dp[1][1]=a[1];
        for(int i=2;i<=k;i++)
        {
            dp[0][i]=min(dp[0][i-1],dp[1][i-1])+a[i];
            dp[1][i]=min(dp[1][i-2],dp[0][i-2])+b[i];
        }
        int ans=min(dp[0][k],dp[1][k]);
        ans+=8*60*60;
        int m=ans/60;
        int s=ans%60;
        int h=m/60;
        m%=60;
        printf("%02d:%02d:%02d %s\n",h>12?h-12:h,m,s,h>12?"pm":"am");

    }
    return 0;
}

努力加油a啊,(o)/~

猜你喜欢

转载自blog.csdn.net/starlet_kiss/article/details/83140714